﻿#target indesign

//Support: InDesign CS3 and late, Windows/Mac
//Alex Dmitrienko, 2021
//alexey-dmitrienko@ya.ru

if( !app.documents.length ){
	alert( 'Нет открытых документов' );
	exit();
	}

var script = {
	name: 'quickRangePrint',
	version: 5.1,
	versionStr: function(){
		return this.version%1 ? this.version.toString() : this.version+'.0';
		},
	insertLabel: function( string ){
		app.insertLabel( this.name, string );
		},
	extractLabel: function(){
		return app.extractLabel( this.name );
		},
	};

//============= VARIABLES =====================================
var autoLoad = 0;//активная кнопка: 0 - текущая страница, 1 - текущий разворот, 2 - выделеная Story, 3 - Document, 4 - Selected area
var showPrintDialog = false;

var showUserPresetsOnly = false;

var lastRange = '';
var printerPresetName = '';
var pdfPrinterPresetName = '';

var toRasterizePDF_jpg = false;
var toRasterizePDF_png = false;

JPEG_color = 'RGB';
JPEG_quality = 'LOW';
JPEG_resolution = 72;

PNG_color = 'RGB';
PNG_quality = 'LOW';
PNG_resolution = 72;

var printSpreads = false; // печать разворотами
var printBlocks = false; // печатать блоками (через запятую: 1-2, 3-5, 10, 12) в отдельные файлы

var lastSelectedFolderPath = app.extractLabel( 'lastSelectedFolderPath' );
var printToLastSelectedFolder = false;

var openOutputFolderAfterPrint = false;

var fileNameMask = '[indd_file_name]';

var activeExportIndex = 0;

var outputFolder;

var DOC = app.activeDocument;
var NEW_DOC;

var CUSTOM_POSTFIX = '';

var DOC_FILE;
try{ DOC_FILE = new File( DOC.fullName ); }catch(err){}; // если это несохраненный документ - выдаст ошибку
var CUSTOM_FILE_NAME = ''; //DOC_FILE ? getFileNameOnly(DOC_FILE) : '';

var toFolderPatches = [];
var toFilePatches = [];
function addToPathes( file ){
	var path = file.fsName.replace(/\\/g,'/');
	var flag = false;
	for( var i = 0; i < toFilePatches.length; i++ ){
		if( path == toFilePatches[i] ){
			if( i != 0 )
				toFilePatches.splice( i, 1 );
			else
				flag = true;
			break;
			}
		}
	if( !flag )
		toFilePatches.unshift( path );	
	
	path = file.parent.fsName.replace(/\\/g,'/');
	flag = false;
	for( var i = 0; i < toFolderPatches.length; i++ ){
		if( path == toFolderPatches[i] ){
			if( i != 0 )
				toFolderPatches.splice( i, 1 );
			else
				flag = true;
			break;
			}
		}
	if( !flag )
		toFolderPatches.unshift( path );
	}

var TO_FOLDER;
var TO_FILE;

var prefs = script.extractLabel();//считываем и запоминаем
eval( prefs );//подгружаем

var settings_button = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\b\x06\x00\x00\x00\x1F\u00F3\u00FFa\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x021IDATx\u00DA\u00A4S\u00B9\u008A\"Q\x14\u00BD\u00E5\u00D6\"*\u00EE\x18\u00B84\u0088\n\"4\u0082\u008A\u00A0\u00A0\r\u0086\u00E6\u00FE\u0080\u0098\x1A\x1A\u00AA\u00FF`b\u00D8\u00A1\u0099\u0081\u00A1\u00E0\f\n\u00AD(Hc\u00E6\u009A(\u0088\u00BB\u0091\u00B8O\u009D\u0087\u00CA\f3\x1D\u00CD\u0083[u\u00EA\u00DEs^\u00DDz\u00E7\x16W(\x14\u00E8\u009B\u0095\u00E5#s\u00C7\u00B9\u00FB\u00F3_Kp\u00BD^)\x1A\u008D\x12\x7F\u00CF\u00F2Q\x05\u00BE?g\u00BE\u00C1Up\u00EF\u0098\u00B8|>\u00FF|\u009B\u00CF\u00E7\u00A3\u00E1pH\x1A\u008D\u0086\u00D4j5i\u00B5Z\u00BA\u00DDn\u00B4^\u00AFi\u00B3\u00D9\u00B0\u00BB\u00CDf\u00A3V\u00AB\u00F5\u00ECJt\u00B9\\\u00F0\x10\u00F6z\u00BD\u00A4\u00D3\u00E9H\u00A9T2\u00E2b\u00B1`\x18\x0B\x18\x1BZ\u00ADV\u0092H$\u00E4\u00F1x\u00A8\u00DDn\u0087\u00D9'`\u0083X,\u00F6\u00DE\u00EF\u00F7i\u00BF\u00DF\u0093@ `d\u00BB\u00DDNb\u00B1\u0098\x050r\u00A8\u0081\x03.4\u00D0\u008A\u00CE\u00E73{\u008BB\u00A1\u00A0\u00F9|Nz\u00BD\u009E^^^\u00A8\u00D1hP\u00BD^g\u00B5P(D\u0081@\u0080\x0E\u0087\x03\u00EB\x06\\,h\x05\u00FC%[,\x16oH\u00A2(\x14\n\u00D1\x1E\u00E2G:\u009D\u00E6\x10\u00C0\u00C8\u00A1\u00F6\u00D8\x00\x1Ah\u00B1A&\x1E\u008F\u0093\u00D1h$\u00B3\u00D9L\"\u0091\u0088\u00BA\u00DD.\u00A5R\u00A9\u00F7\u0087U\u00C0\u00C8\u00A1\x06\x0E\u00B8\u00D0@+:\u009DN4\u0099L\u00FE\u00F0\u00F6\u00D1\u00E2\u00BFr\u00E0\u00C3\x11\x04\u00B00\x18\fr\u0083\u00C1 \u0082\x13\u009FN\u00A7d0\x18H.\u0097\u00D3\u00E7\u00E7g\u00C4\u00E1p|@T.\u0097\u00ABn\u00B7\u00FBU*\u0095\u00B2\u00EEpx\u00B5Z\rs\u0090cg\u0090H$\u00B8\u00E5r\u00C9\u0084\u00BB\u00DD\u008E\u00D9\u00E5r\u00B9\"\u0095J\u00E5\u0086\x00F\x0E5p\u00C0\u0085\x06\u00DA\u00A7\x0B8\x1C\u0093\u00C9\u00C4\x1C\u0098\u00CDf\u00CC6L\x1B\x16\u00DAEN&\u0093\u00B1\r`\u00E3\u00C3\x05\u00A1\u00DF\u00EF\u00A7f\u00B3Yu:\u009D\u00AF\x18\u00A6\u00D1h\u00C4\u00C8\u00BD^\u008F\u008E\u00C7#\u00B3\u00F6\u00EB\u00EB\u008BY\u0088\u00D6\u00F9O\u00A1\u00EDvK\u00A5R)\u00C2O\u00E9\u00C7c\x12\x7F\u00F26E\u0080\u00C7\u00E31{\u00BBJ\u00A5\u00A2\u00DFgd\u00B5Z\x11\x7FV\u00AC\u00FDN\u00A7\u00C34\u00CFI\f\u0087\u00C3Y\u00FE\u009E\u0083\u00DFooo\u009C\u00C5b\u0081\u00F7\u00ECgA\x00#\u0087\x1A8\u00E0\u00DE5\u00C4%\u0093\u00C9\u00FF\u00FA\u009D\x7F\t0\x00I\\i\u00A5H\x00\u00EA^\x00\x00\x00\x00IEND\u00AEB`\u0082";

var ru2en_basa = {'А':"A", 'Б':"B", 'В':"V", 'Г':"G", 'Д':"D", 'Е':"E", 'Ё':"JO", 'Ж':"ZH", 'З':"Z", 'И':"I", 'Й':"J", 'К':"K", 'Л':"L", 'М':"M", 'Н':"N", 
	'О':"O", 'П':"P", 'Р':"R", 'С':"S", 'Т':"T", 'У':"U", 'Ф':"F", 'Х':"H", 'Ц':"C", 'Ч':"CH", 'Ш':"SH", 'Щ':"SHH", 'Ъ':"", 'Ы':"I", 'Ь':"", 'Э':"JE", 'Ю':"JU", 'Я':"JA", 
	'а':"a", 'б':"b", 'в':"v", 'г':"g", 'д':"d", 'е':"e", 'ё':"jo", 'ж':"zh", 'з':"z", 'и':"i", 'й':"j", 'к':"k", 'л':"l", 'м':"m", 'н':"n", 
	'о':"o", 'п':"p", 'р':"r", 'с':"s", 'т':"t", 'у':"u", 'ф':"f", 'х':"h", 'ц':"c", 'ч':"ch", 'ш':"sh", 'щ':"shh", 'ъ':"", 'ы':"i", 'ь':"", 'э':"je", 'ю':"ju", 'я':"ja",
	' ': " ",
	};
function ru2en( STR ){ // использует глобальную переменную ru2en_basa
	var EN_STR = '';
	for( var i = 0; i < STR.length; i++ )
		EN_STR += ru2en_basa.hasOwnProperty( STR[i] ) ? ru2en_basa[STR[i]] : STR[i];
	return EN_STR;
	}

//============= MAIN =====================================

var pageRange = false;
var selected_items_to_image;
while( true ){
	TO_FOLDER = undefined;
	TO_FILE = undefined;
	pageRange = getDialog( pageRange );
	if( !pageRange )
		break;
	
	lastRange = pageRange;
	
	// Print selected area
	if( autoLoad == 4 ){
		var DOC_IS_MODIFIED = DOC.modified;
		
		DOC.zeroPoint = [0,0];
		// устанавливаем координаты для всего разворота (координаты для отдельной страницы не годятся в любом случае)
		DOC.viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;

		var SEL = app.selection;
		var PAGE = SEL[0].parentPage;

		var SEL_BOUNDS = [SEL[0].visibleBounds[0], SEL[0].visibleBounds[1], SEL[0].visibleBounds[2], SEL[0].visibleBounds[3] ];

		// Определяем общие габариты выделенения
		for( i = 1; i < SEL.length; i++ ){
			if( !SEL[i].parentPage )
				continue;
			// top
			SEL_BOUNDS[0] = Math.min( SEL[i].visibleBounds[0], SEL_BOUNDS[0] );
			// left
			SEL_BOUNDS[1] = Math.min( SEL[i].visibleBounds[1], SEL_BOUNDS[1] );
			// bottom
			SEL_BOUNDS[2] = Math.max( SEL[i].visibleBounds[2], SEL_BOUNDS[2] );
			// right
			SEL_BOUNDS[3] = Math.max( SEL[i].visibleBounds[3], SEL_BOUNDS[3] );
			}
		// габариты выделения в пределах страницы
		var SEL_BOUNDS_ON_PAGE = [
			Math.max( PAGE.bounds[0], SEL_BOUNDS[0] ),
			Math.max( PAGE.bounds[1], SEL_BOUNDS[1] ),
			Math.min( PAGE.bounds[2], SEL_BOUNDS[2] ),
			Math.min( PAGE.bounds[3], SEL_BOUNDS[3] )
			];
		// если габариты выделения не выходят за пределы страницы и это печать в jpg/png
		if( SEL_BOUNDS.toString() == SEL_BOUNDS_ON_PAGE.toString() && (activeExportIndex == 2 || activeExportIndex == 3)  ){
			selected_items_to_image = true;
			}
		else{ // в противном случае - печатаем через другой документ
			if( DOC_IS_MODIFIED ){
				var res;
				var _win = new Window( 'dialog' );
				_win.add( 'statictext', undefined, 'Документ должен быть сохранен. Сохранить?' );
				_win.buts = _win.add( 'group' );
				_win.buts.orientation = 'row';
				_win.buts.ok = _win.buts.add( 'button', undefined, 'Ok' );
				_win.buts.no = _win.buts.add( 'button', undefined, 'No' );
				_win.buts.cancel = _win.buts.add( 'button', undefined, 'Cancel' );
				_win.buts.ok.onClick = _win.buts.no.onClick = _win.buts.cancel.onClick = function(){
					res = this.text;
					_win.close();
					}
				_win.center();
				_win.show();
				if( res == 'Ok' )
					DOC.save();
				else if( res == 'Cancel' )
					break;
				}
			pageRange = '1';
			NEW_DOC = app.documents.add(
				{ documentPreferences: {
					pageWidth: SEL_BOUNDS_ON_PAGE[3]-SEL_BOUNDS_ON_PAGE[1], 
					pageHeight: SEL_BOUNDS_ON_PAGE[2]-SEL_BOUNDS_ON_PAGE[0], 
					zeroPoint: [0,0],
					// выносы за обрез
					documentBleedBottomOffset: 0,
					documentBleedInsideOrLeftOffset: 0,
					documentBleedOutsideOrRightOffset: 0,
					documentBleedTopOffset: 0,
					// поля
					slugBottomOffset: 0,
					slugInsideOrLeftOffset: 0,
					slugRightOrOutsideOffset: 0,
					slugTopOffset: 0
					}
				}
				);
			app.importedPageAttributes.pageNumber = PAGE.documentOffset + 1;
			app.importedPageAttributes.importedPageCrop = ImportedPageCropOptions.CROP_CONTENT;
			
			// У метода place нет параметра "поместить разворотом". Как выход - перед помещением изменять выносы первой страницы на весь разворот и помещать с параметром кадрирования по выносам
			NEW_DOC.pages[0].place( new File(DOC.fullName), [0,0] );
			NEW_DOC.pages[0].pageItems[0].move( [PAGE.bounds[1]-SEL_BOUNDS_ON_PAGE[1],PAGE.bounds[0]-SEL_BOUNDS_ON_PAGE[0]] );
			}
		}
	
	if( activeExportIndex == 1 && pdfPrinterPresetName ){
		// pageRange
		try{ 
			app.pdfExportPreferences.pageRange = pageRange.replace(/\s/g, '');
//			app.documents[0].pdfExportPreferences.pageRange = pageRange.replace(/\s/g, '');
			} catch(err){ 
				alert( 'Incorrect value:\r\r' + pageRange ); 
				continue;
				}
		
		// to file
		var to_pdf_file = getOutputFile( 'pdf' );
		if( !to_pdf_file )
			break;
		outputFolder = to_pdf_file.parent; //openOutputFolderAfterPrint
		
		if( toRasterizePDF_jpg || toRasterizePDF_png ){
			var type = toRasterizePDF_jpg ? 'jpg' : 'png';
			
			var fileName = getFileNameOnly(to_pdf_file);
			var blocks = printBlocks ? pageRange.replace(/\s/g, '').split(',') : [pageRange];
			for( var i = 0; i < blocks.length; i++ ){
				var this_to_pdf_file = printBlocks ? new File(to_pdf_file.parent.absoluteURI + '/' + fileName + '_p' + blocks[i].replace(/:/g,'_') + '.pdf' ) : to_pdf_file;
				if( !do_check_file_permission(this_to_pdf_file) )
					continue;
				exportToRasterizePDF( blocks[i], this_to_pdf_file, type ); // type = jpg|png
				}
			}
		else{
			// открываем панель Фоновые операции
			var _91382_checked;
			if( !app.menuActions.itemByID(91382).checked ){
				app.menuActions.itemByID(91382).invoke();
				_91382_checked = true;
				}
			
			var fileName = getFileNameOnly(to_pdf_file);
			var blocks = printBlocks ? pageRange.replace(/\s/g, '').split(',') : [pageRange];
			for( var i = 0; i < blocks.length; i++ ){
				var this_to_pdf_file = printBlocks ? new File(to_pdf_file.parent.absoluteURI + '/' + fileName + '_p' + blocks[i].replace(/:/g,'_') + '.pdf' ) : to_pdf_file;
				if( !do_check_file_permission(this_to_pdf_file) )
					continue;
				app.pdfExportPreferences.pageRange = blocks[i];
				if( printSpreads ){
					app.pdfExportPreferences.properties = app.pdfExportPresets.item(pdfPrinterPresetName).properties;
					app.pdfExportPreferences.exportReaderSpreads = true;
					
					app.activeDocument.asynchronousExportFile( ExportFormat.PDF_TYPE, this_to_pdf_file, false ); //format: varies, to: File[, showingOptions: bool=false][, using: PDFExportPreset][, versionComments: string][, forceSave: bool=false])
			//		app.activeDocument.exportFile( ExportFormat.PDF_TYPE, to_pdf_file, false );
					}
				else{
					app.activeDocument.asynchronousExportFile( ExportFormat.PDF_TYPE, this_to_pdf_file, false, app.pdfExportPresets.item(pdfPrinterPresetName) ); //format: varies, to: File[, showingOptions: bool=false][, using: PDFExportPreset][, versionComments: string][, forceSave: bool=false])
			//		app.activeDocument.exportFile( ExportFormat.PDF_TYPE, to_pdf_file, false, app.pdfExportPresets.item(pdfPrinterPresetName) );
					}
				}
			
			/*
			var time_limit = 60; // лимит ожидания - 60 сек
			var step = 2;
			while( time_limit && !do_check_file_permission(to_pdf_file, true) ){
				$.sleep(1000);
				time_limit -= step;
				}
			// закрывем панель Фоновые операции
			if( _91382_checked )
				app.menuActions.itemByID(91382).invoke();
			*/
			}
		}
	else if( activeExportIndex == 0 && printerPresetName ){
		try{ 
			app.activeDocument.printPreferences.pageRange = pageRange.replace(/\s/g, '');
			} catch(err){ 
				alert( 'Incorrect value:\r\r' + pageRange ); 
				continue;
				}
		if( printBlocks ){
			alert( 'Option "print blocks" not supported with Printer Preset.\rUse PDF Export Preset' ); 
			continue;
			}
		/* НЕ РАБОТАЕТ
		// to file
		var to_pdf_file = File.openDialog( 'Save as...', '*.pdf' );
		if( to_pdf_file && do_check_file_permission(to_pdf_file) ){
			app.activeDocument.printPreferences.printFile = to_pdf_file;
			app.activeDocument.print( showPrintDialog, app.printerPresets.item(printerPresetName) );
			}
		*/
		app.activeDocument.printPreferences.activePrinterPreset = app.printerPresets.item( printerPresetName );
		app.activeDocument.printPreferences.printSpreads = printSpreads;
		app.activeDocument.print( showPrintDialog );
		//	app.activeDocument.print( showPrintDialog, printerPresetName ? app.printerPresets.item(printerPresetName) : 1131639917 );//PrinterPresetTypes.CUSTOM
		}
	else if( activeExportIndex == 2 ){
		var to_jpg_file = getOutputFile( 'jpg' );
		if( !to_jpg_file )
			break;
		outputFolder = to_jpg_file.parent; //openOutputFolderAfterPrint
		
		app.jpegExportPreferences.properties = {
			exportResolution: JPEG_resolution,
			exportingSpread: printSpreads,
			jpegExportRange: ExportRangeOrAllPages.EXPORT_RANGE,
			pageString: pageRange,
			jpegColorSpace: JpegColorSpaceEnum[JPEG_color],
			jpegQuality: JPEGOptionsQuality[JPEG_quality],
			}
		if( selected_items_to_image ){
			var lastUndoIndex = app.activeDocument.undoHistory.length;//длинна массива отмен на момент запуска скрипта
			var pageItem = app.selection[0];
			if( app.selection.length > 1 ){
				 pageItem = pageItem.parentPage.parent.groups.add( app.selection );
				}
			pageItem.exportFile( ExportFormat.JPG, to_jpg_file, false );
					
			if( lastUndoIndex < app.activeDocument.undoHistory.length )
				for(var i = app.activeDocument.undoHistory.length; i > lastUndoIndex; i--)
					app.activeDocument.undo();
			}
		else
			app.activeDocument.exportFile( ExportFormat.JPG, to_jpg_file, showPrintDialog );
		}
	
	else if( activeExportIndex == 3 ){
		var to_png_file = getOutputFile( 'png' );
		if( !to_png_file )
			break;
		outputFolder = to_png_file.parent; //openOutputFolderAfterPrint
		
		app.pngExportPreferences.properties = {
			exportResolution: PNG_resolution,
			exportingSpread: printSpreads,
			pngExportRange: PNGExportRangeEnum.EXPORT_RANGE,
			pageString: pageRange,
			pngColorSpace: PNGColorSpaceEnum[PNG_color],
			pngQuality: PNGQualityEnum[PNG_quality],
			}
		if( selected_items_to_image ){
			var lastUndoIndex = app.activeDocument.undoHistory.length;//длинна массива отмен на момент запуска скрипта
			var pageItem = app.selection[0];
			if( app.selection.length > 1 ){
				 pageItem = pageItem.parentPage.parent.groups.add( app.selection );
				}
			pageItem.exportFile( ExportFormat.PNG_FORMAT, to_png_file, false );
					
			if( lastUndoIndex < app.activeDocument.undoHistory.length )
				for(var i = app.activeDocument.undoHistory.length; i > lastUndoIndex; i--)
					app.activeDocument.undo();
			}
		else{
			app.activeDocument.exportFile( ExportFormat.PNG_FORMAT, to_png_file, showPrintDialog );
			}
		}
	
	if( openOutputFolderAfterPrint && outputFolder )
		outputFolder.execute();
	
	if( NEW_DOC && activeExportIndex != 1 ){
		NEW_DOC.close( SaveOptions.NO );
		app.activeDocument = DOC;
		}
	
	break;
	}



savePrefs();

//============= FUNCTIONS =====================================
function exportToRasterizePDF( pageRange, to_pdf_file, type ){ // type = jpg|png
	
	var CURRENT_DOC = app.activeDocument;
	
	type = type == 'png' ? 'png' : 'jpg';
	
	if( type == 'png' ){
		app.pngExportPreferences.properties = {
			exportResolution: PNG_resolution,
			exportingSpread: printSpreads,
			pngExportRange: PNGExportRangeEnum.EXPORT_RANGE,
			pageString: pageRange,
			pngColorSpace: PNGColorSpaceEnum[PNG_color],
			pngQuality: PNGQualityEnum[PNG_quality],
			}
		}
	else{
		app.jpegExportPreferences.properties = {
			exportResolution: JPEG_resolution,
			exportingSpread: printSpreads,
			jpegExportRange: ExportRangeOrAllPages.EXPORT_RANGE,
			pageString: pageRange,
			jpegColorSpace: JpegColorSpaceEnum[JPEG_color],
			jpegQuality: JPEGOptionsQuality[JPEG_quality],
			}
		}
	
	var _toFolder = new Folder(to_pdf_file.parent.fsName.replace(/\\/g,'/') + '/_' + new Date().getTime() );
	_toFolder.create();
	var exportFormat = type == 'png' ? ExportFormat.PNG_FORMAT : ExportFormat.JPG;
	app.activeDocument.exportFile( exportFormat, _toFolder.fsName+'/'+getFileNameOnly(to_pdf_file)+'.'+type, showPrintDialog );
	var _doc = app.documents.add(
		{ documentPreferences: {
			pageWidth: app.documents[0].pages[0].bounds[3] * (printSpreads ? 2 : 1), 
			pageHeight: app.documents[0].pages[0].bounds[2], 
			zeroPoint: [0,0],
			// выносы за обрез
			documentBleedBottomOffset: 0,
			documentBleedInsideOrLeftOffset: 0,
			documentBleedOutsideOrRightOffset: 0,
			documentBleedTopOffset: 0,
			// поля
			slugBottomOffset: 0,
			slugInsideOrLeftOffset: 0,
			slugRightOrOutsideOffset: 0,
			slugTopOffset: 0
			}
		}
		);
	//app.importedPageAttributes.pageNumber = PAGE.documentOffset + 1;
	//app.importedPageAttributes.importedPageCrop = ImportedPageCropOptions.CROP_CONTENT;
	
	var _files = _toFolder.getFiles();
	for( var i = 0; i < _files.length; i++ ){
		// У метода place нет параметра "поместить разворотом". Как выход - перед помещением изменять выносы первой страницы на весь разворот и помещать с параметром кадрирования по выносам
		_doc.pages[i].place( _files[i], [0,0] );
		//NEW_DOC.pages[i].pageItems[0].move( [PAGE.bounds[1]-SEL_BOUNDS_ON_PAGE[1],PAGE.bounds[0]-SEL_BOUNDS_ON_PAGE[0]] );
		if( _files[i+1] )
			_doc.pages.add();
		}
	
	app.pdfExportPreferences.pageRange = '1'+(_files.length > 1 ? '-'+_files.length : '');
	if( printSpreads ){
		app.pdfExportPreferences.properties = app.pdfExportPresets.item(pdfPrinterPresetName).properties;
		app.pdfExportPreferences.exportReaderSpreads = true;
		
		//app.activeDocument.asynchronousExportFile( ExportFormat.PDF_TYPE, to_pdf_file, false ); //format: varies, to: File[, showingOptions: bool=false][, using: PDFExportPreset][, versionComments: string][, forceSave: bool=false])
		app.activeDocument.exportFile( ExportFormat.PDF_TYPE, to_pdf_file, false );
		}
	else{
		//app.activeDocument.asynchronousExportFile( ExportFormat.PDF_TYPE, to_pdf_file, false, app.pdfExportPresets.item(pdfPrinterPresetName) ); //format: varies, to: File[, showingOptions: bool=false][, using: PDFExportPreset][, versionComments: string][, forceSave: bool=false])
		app.activeDocument.exportFile( ExportFormat.PDF_TYPE, to_pdf_file, false, app.pdfExportPresets.item(pdfPrinterPresetName) );
		}
	_doc.close( SaveOptions.NO );
	app.activeDocument = CURRENT_DOC;
	
	for( var i = 0; i < _files.length; i++ )
		 _files[i].remove();
	_toFolder.remove();
	}


function getOutputFile( ext ){ // ext = 'pdf' | 'jpg' | 'png'
	var docFile;
	var toFile;
	try{ docFile = new File( DOC.fullName ); }catch(err){}; // если это несохраненный документ - выдаст ошибку
	if( TO_FILE){
		toFile = TO_FILE;
		TO_FILE = undefined;
		if( ext && toFile.fullName.split('.').reverse()[0] != ext )
			toFile = new File( toFile.fullName.replace(/\.[^.]+$/, '.'+ext) );
		}
	else if( TO_FOLDER ){
		toFile = new File( TO_FOLDER + '/' + CUSTOM_FILE_NAME + '.' + ext );
		TO_FOLDER = undefined;
		}
	else if( docFile ){
		var toFolder = docFile.parent;
		if( printToLastSelectedFolder && lastSelectedFolderPath ){
			var _folder = new Folder( lastSelectedFolderPath );
			// try{ _folder.create(); }catch(err){}
			if( _folder.exists )
				toFolder = _folder;
			}
		
		toFile = new File( toFolder + '/' + CUSTOM_FILE_NAME + '.' + ext ).openDlg( 'Save as...', '*.'+ext );
		}
	else
		toFile = File.openDialog( 'Save as...', '*.'+ext );
	
	if( toFile ){
		lastSelectedFolderPath = toFile.parent.absoluteURI;
		addToPathes( toFile );
		}
	
	return toFile;
	}
function do_check_file_permission( file, notDoAlertError ){ // return Bool
	if( !file.exists )
		return true;
	file.error = ''; // обнуляем error если до этого были обращения к файлу
	file.rename( getFileName(file) );
	if( file.error && !notDoAlertError )
		alert( "File '"+file.fsName+"':\r"+file.error, script.name+' v'+script.versionStr(), true );
	return ( file.error ? false : true ); // если файл открыт в другом приложении - вызовет ошибку 'Permission denied'
	}
function getDialog( pageRange ){
	try{
	var returnPageRange = false;
	var win = new Window( 'dialog', script.name+' '+script.versionStr() );
	win.preferredSize.width = 600;// = [150,50];
	win.alignChildren = ['fill','top'];
	win.margins = 5;
	win.spacing = 5;

	win.quick = win.add( 'group' );
	win.quick.orientation = 'row';
	win.quick.alignment = ['center','top'];
	win.quick.preferredSize.width = 400;// = [150,50];
	win.quick.alignChildren = ['fill','top'];
	win.quick.spacing = 5;
	
	//QUICK BUTTONS
	win.quick.buts = [];
	var PREF_SIZE = [50,30];
	win.quick.buts[0] = win.quick.add( 'iconbutton', undefined, undefined, {name: 0} );
	addIcon( {iconButton: win.quick.buts[0], iconPath: '/UI/(CommandBar Resources)/idrc_PNGR/300.idrc', text: 'current page'} );
	win.quick.buts[0].helpTip = 'current page';
	win.quick.buts[0].preferredSize = PREF_SIZE;
	
	win.quick.buts[1] = win.quick.add( 'iconbutton', undefined, undefined, {name: 1} );
	addIcon( {iconButton: win.quick.buts[1], iconPath: '/Layout/(Pages Panel Resources)/idrc_PNGR/900.idrc', text: 'current spread'} );
	win.quick.buts[1].helpTip = 'current spread';
	win.quick.buts[1].preferredSize = PREF_SIZE;
	
	win.quick.buts[2] = win.quick.add( 'iconbutton', undefined, undefined, {name: 2} );
	addIcon( {iconButton: win.quick.buts[2], iconPath: '/Graphics/(DynamicDocumentsUI Resources)/idrc_PNGR/4000.idrc', text: 'selected story'} );
	win.quick.buts[2].helpTip = 'selected story';
	win.quick.buts[2].preferredSize = PREF_SIZE;
	
	win.quick.buts[3] = win.quick.add( 'iconbutton', undefined, undefined, {name: 3} );
	addIcon( {iconButton: win.quick.buts[3], iconPath: '/Layout/(Asset Library Panel Resources)/idrc_PNGA/1217.idrc', text: 'document'} );
	win.quick.buts[3].helpTip = 'document';
	win.quick.buts[3].preferredSize = PREF_SIZE;
	
	win.quick.buts[4] = win.quick.add( 'iconbutton', undefined, undefined, {name: 4} ); 
	addIcon( {iconButton: win.quick.buts[4], iconPath: '/PMPack/(PositionTool Resources)/idrc_PNGR/135.idrc', text: 'selected area'} ); // /Graphics/(DynamicDocumentsUI Resources)/idrc_PNGR/8005.idrc
	win.quick.buts[4].helpTip = 'selected area';
	win.quick.buts[4].preferredSize = PREF_SIZE;
	
	
	function addIcon( opts ){ // opts = { iconButton, iconPath, text, helpTip }
		try{
		var icon;
		if( opts.iconPath.split('.').reverse()[0].toLowerCase() == 'idrc' ){
			icon = getInDesignIcon( opts.iconPath ); // example: script.getInDesignIcon( '/Text/(Find and Change Panel Resources)/idrc_PNGA/113.idrc' );
			if( !icon ){
		//		alert( 'Incorrect path: ' + opts.iconPath );
				}
			}
		else{
			var file = new File(opts.iconPath);
			if( !file.exists ){
		//		alert 'File not found: ' + file.fsName );
				}
			else
				icon = ScriptUI.newImage( file.fsName );
			}
		
		if( icon ){
	//		var uiObject_size = opts.iconButton.size ? opts.iconButton.size : opts.iconButton.preferredSize;
	//		if( icon.size[0] <= uiObject_size[0] && icon.size[1] <= uiObject_size[1] )
				opts.iconButton.image = icon;
	//		else{  // если иконка  не вписывается в габариты
	//			getCustomDraw(opts.iconButton, {uiImage: icon});
	//			}
			opts.iconButton.active = false;
			}
		else if( opts.text )
			getCustomDraw(opts.iconButton, {text:opts.text});
		
		if( opts.helpTip )
			opts.iconButton.helpTip = opts.helpTip;
		
		return true;
		}catch( err ){
			alert (err  + ', line ' + err.line );
			return err;
			}
		}
	
	if( !getPageRange("selected area") ){
		win.quick.buts[4].enabled = false;
		autoLoad = 0;
		}
	
	win.quick.buts[0].onClick = win.quick.buts[1].onClick = win.quick.buts[2].onClick = win.quick.buts[3].onClick = win.quick.buts[4].onClick = function(){
		var range = this.helpTip; // this.text
		
		var str = getPageRange( range );
		if( !str ){
			if( win.visible )
				alert( range + ' is not available');
			return;
			}
		autoLoad = this.properties.name;
		win.range.edit.enabled = range != 'selected area';
		win.range.edit.text = pageRange = str;
		for( var i = 0; i < win.quick.buts.length; i++ ){
			var opts = false;
			if( win.quick.buts[i] == this ){
				opts = {bgRGB: [0,255,255]};
				if( this.image )
					opts.uiImage = this.image;
				else{
					opts.text = this.helpTip;
					opts.size = 10;
					}
				}
			else if( !win.quick.buts[i].image )
				opts = {text: win.quick.buts[i].helpTip, size: 10};
			getCustomDraw( win.quick.buts[i], opts ); // args = { text: 'myButton', font: 'Tahoma', style: 'Bold', size: 12, textRGB: [0,0,0], bgRGB: [0,0,0] }
			}
		}
	
	//PAGES
	win.range = win.add( 'group' );
	win.range.orientation = 'row';
	win.range.alignChildren = 'fill';
	win.range.spacing = 5;
	with(win.range){
		win.range.lastRange = add('button', undefined , '>');
		win.range.edit = add('edittext', undefined , undefined);
		win.range.showPrintDialog = add('checkbox', undefined , 'show print dialog');
		win.range.rangeToSinglePages = add('button', undefined , 'range to single pages');
		win.range.rangeToSinglePages.helpTip = "Преобразовать диапазон страниц вида '1-5' в вид '1, 2, 3, 4, 5'";
		}
	
	win.range.lastRange.preferredSize = [22,22];
	if( lastRange )
		win.range.lastRange.helpTip = lastRange;
	win.range.lastRange.enabled = lastRange ? true : false;
	
	win.range.edit.preferredSize = [200,22];
	addFont( win.range.edit, {style:'Bold'} );
	addColor( win.range.edit, 1, [255,0,0] );
	
	win.range.lastRange.onClick = function(){
		if( this.helpTip ){
			win.range.edit.enabled = true;
			pageRange = win.range.edit.text = this.helpTip;
			}
		}
	win.range.edit.onChange = function(){
		pageRange = this.text;
		}
	win.range.showPrintDialog.value = showPrintDialog;
	win.range.showPrintDialog.onClick = function(){
		showPrintDialog = this.value;
		if( showPrintDialog && win.printBlocks.value ){
			win.printBlocks.value = false;
			win.printBlocks.onClick();
			}
		}
	win.range.rangeToSinglePages.onClick = function(){
		var basa = {};
		var ranges = win.range.edit.text.split(/\s*,\s*/);
		for( var i = 0; i < ranges.length; i++ ){
			 if(ranges[i].indexOf ('-') != -1){
				 var nums = ranges[i].split(/\s*-\s*/);
				 for( var i = +nums[0]; i <= +nums[1]; i++ ){
					 basa[i] = true;
					 }
				 }
			 else
				basa[+ranges[i]] = true;
			}
		var pages = [];
		for( var i in basa )
			pages.push( i );
		pageRange = win.range.edit.text = pages.join( ', ' );
		}
	
	win.printSpreadsAndBlocks = win.add('group');
    win.printSpreadsAndBlocks.orientation = 'row';
    // printSpreads
	win.printSpreads = win.printSpreadsAndBlocks.add('checkbox', undefined , 'Print spreads');
	win.printSpreads.helpTip = 'Печатать разворотами';
	win.printSpreads.preferredSize.width = 100;
	win.printSpreads.value = printSpreads;
	win.printSpreads.onClick = function(){
		printSpreads = this.value;
		addColor( this, 1, this.value?[255,0,0]:[0,0,0] );//type: 0 = backgroundColor, 1 = foregroundColor (fontColor), RGB - Array or uiobject. Return uiObject.graphics.[type]Color or false
		addFont( this, {style: this.value?'Bold':'Regular'} );// args = arguments or uiObject, return uiobject.graphics.font or false. Code of arguments: { font: 'Tahoma', style: 'Bold', size: 12 }, (style: Regular, Bold, Italic, Bolditalic)
		}
	win.printSpreads.onClick();
    // printBlocks
	win.printBlocks = win.printSpreadsAndBlocks.add('checkbox', undefined , 'Print blocks');
	win.printBlocks.preferredSize.width = 100;
	win.printBlocks.helpTip = "Печатать блоки (через запятую: 1-2, 3-5, 10, 12) в отдельные файлы";
	win.printBlocks.value = printBlocks;
	win.printBlocks.onClick = function(){
		printBlocks = this.value;
		addColor( this, 1, this.value?[255,0,0]:[0,0,0] );//type: 0 = backgroundColor, 1 = foregroundColor (fontColor), RGB - Array or uiobject. Return uiObject.graphics.[type]Color or false
		addFont( this, {style: this.value?'Bold':'Regular'} );// args = arguments or uiObject, return uiobject.graphics.font or false. Code of arguments: { font: 'Tahoma', style: 'Bold', size: 12 }, (style: Regular, Bold, Italic, Bolditalic)
		
		if( printBlocks ){
			win.range.showPrintDialog.value = showPrintDialog = false;
			}
		}
	win.printBlocks.onClick();
    
	
	//PRESETS
	var printerPresetsArray = app.printerPresets.everyItem().name;
	if( showUserPresetsOnly ){
		for( var i = printerPresetsArray.length-1; i > -1; i-- )
			if( printerPresetsArray[i].indexOf('[') == 0 )
				printerPresetsArray.splice( i, 1 );
		}
	printerPresetsArray.sort().reverse();
	
	var PDFExportPresetsArray = app.pdfExportPresets.everyItem().name;
	if( showUserPresetsOnly ){
		for( var i = PDFExportPresetsArray.length-1; i > -1; i-- )
			if( PDFExportPresetsArray[i].indexOf('[') == 0 )
				PDFExportPresetsArray.splice( i, 1 );
		}
	PDFExportPresetsArray.sort().reverse();
	
	win.group = win.add( 'tabbedpanel' );
	win.group.orientation = 'row';
	win.group.alignment= ['fill','top'];
	
	win.group.onChange = function(){
		activeExportIndex = this.selection._index;
		}
	
	//PRINT PRESETS
	win.group.printerPresets = win.group.add( 'tab', undefined , 'Printer preset' );
	win.group.printerPresets._index = 0;
	win.group.printerPresets.margins = [2,10,2,2];
	win.group.printerPresets.alignChildren = ['fill','fill'];
	
	// FIX: In InDesign CS6 on Windows 10 you have to place the listbox in a group or a panel
	win.group.printerPresets.list_group = win.group.printerPresets.add( 'group');
	win.group.printerPresets.list_group.alignChildren = ['fill','fill'];
	win.group.printerPresets.list = win.group.printerPresets.list_group.add( 'listbox', undefined , undefined, {items: printerPresetsArray});
//	win.group.printerPresets.list.preferredSize = [150,18*printerPresetsArray.length];
	win.group.printerPresets.list.maximumSize.height = 500;
	win.group.printerPresets.list.onChange = function(){
		printerPresetName = this.selection.text;
		}
	
	//PDF EXPORT PRESETS
	win.group.PDFExportPresets = win.group.add( 'tab', undefined , 'PDF Export preset' );
	win.group.PDFExportPresets._index = 1;
	win.group.PDFExportPresets.margins = [2,10,2,2];
	win.group.PDFExportPresets.alignChildren = ['fill','fill'];
	
	// FIX: In InDesign CS6 on Windows 10 you have to place the listbox in a group or a panel
	win.group.PDFExportPresets.list_group = win.group.PDFExportPresets.add('group');
	win.group.PDFExportPresets.list_group.alignChildren = ['fill','fill'];
	win.group.PDFExportPresets.list_group.orientation = 'row';
	win.group.PDFExportPresets.list = win.group.PDFExportPresets.list_group.add( 'listbox', undefined , undefined, {items: PDFExportPresetsArray});
	win.group.PDFExportPresets.list.maximumSize.height = 500;
	win.group.PDFExportPresets.list.minimumSize.width = 400;
	
	win.group.PDFExportPresets.list_group.rasterizeGroup = win.group.PDFExportPresets.list_group.add('group');
	win.group.PDFExportPresets.list_group.rasterizeGroup.margins = [2,10,2,2];
	win.group.PDFExportPresets.list_group.rasterizeGroup.orientation = 'column';
	win.group.PDFExportPresets.list_group.rasterizeGroup.alignChildren = ['left','top'];
	//win.group.PDFExportPresets.list_group.rasterizeGroup.preferredSize.width = 100;
	
	win.group.PDFExportPresets.toRasterizePDF_jpg = win.group.PDFExportPresets.list_group.rasterizeGroup.add('checkbox', undefined , 'растрировать в jpg');
	win.group.PDFExportPresets.toRasterizePDF_jpg.value = toRasterizePDF_jpg;
	win.group.PDFExportPresets.toRasterizePDF_jpg.helpTip = "Растрирование страниц в jpg с текущими настройками вкладки 'JPEG EXPORT'";
	win.group.PDFExportPresets.toRasterizePDF_jpg.onClick = function(){
		toRasterizePDF_jpg = this.value;
		toRasterizePDF_png = win.group.PDFExportPresets.toRasterizePDF_png.value = false;
		}
	
	win.group.PDFExportPresets.toRasterizePDF_png = win.group.PDFExportPresets.list_group.rasterizeGroup.add('checkbox', undefined , 'растрировать в png');
	win.group.PDFExportPresets.toRasterizePDF_png.value = toRasterizePDF_png;
	win.group.PDFExportPresets.toRasterizePDF_png.helpTip = "Растрирование страниц в png с текущими настройками вкладки 'PNG EXPORT'";
	win.group.PDFExportPresets.toRasterizePDF_png.onClick = function(){
		toRasterizePDF_png = this.value;
		toRasterizePDF_jpg = win.group.PDFExportPresets.toRasterizePDF_jpg.value = false;
		}
	
//	win.group.PDFExportPresets.list.preferredSize = [150,18*PDFExportPresetsArray.length];
	win.group.PDFExportPresets.list.onChange = function(){
		pdfPrinterPresetName = this.selection.text;
		}
	// JPEG
	win.group.JPEGExport = win.group.add( 'tab', undefined , 'JPEG Export' );
	win.group.JPEGExport._index = 2;
	win.group.JPEGExport.margins = [5,10,5,5];
	win.group.JPEGExport.alignChildren = ['left','top'];
	with( win.group.JPEGExport ){
		win.group.JPEGExport.Resolution = add( 'group' );
		win.group.JPEGExport.Resolution.alignChildren = ['left','center'];
		win.group.JPEGExport.Resolution.spacing = 10;
		with( win.group.JPEGExport.Resolution ){
			add( 'statictext', undefined, 'Resolution' );
			win.group.JPEGExport.Resolution.Wrap = add( 'group' );
			win.group.JPEGExport.Resolution.Wrap.orientation = 'stack';
			win.group.JPEGExport.Resolution.Wrap.alignChildren = ['left','top'];
			with( win.group.JPEGExport.Resolution.Wrap ){
				win.group.JPEGExport.Resolution.Value = add( 'edittext' );
				win.group.JPEGExport.Resolution.Value.preferredSize.width = 110;
				win.group.JPEGExport.Resolution.List = add( 'dropdownlist', undefined, undefined, {items: [72,150,300]} );
				win.group.JPEGExport.Resolution.List.preferredSize.width = 130;
				}
			}
		win.group.JPEGExport.Color = add( 'dropdownlist', undefined, undefined, {items: ['RGB','CMYK','GRAY']} );
		win.group.JPEGExport.Color.title = 'Color';
		win.group.JPEGExport.Color.preferredSize.width = 200;
		win.group.JPEGExport.Quality = add( 'dropdownlist', undefined, undefined, {items: ['MAXIMUM','HIGH','MEDIUM','LOW']} );
		win.group.JPEGExport.Quality.title = 'Quality';
		win.group.JPEGExport.Quality.preferredSize.width = 200;
		}
	// PNG
	win.group.PNGExport = win.group.add( 'tab', undefined , 'PNG Export' );
	win.group.PNGExport._index = 3;
	win.group.PNGExport.margins = [5,10,5,5];
	win.group.PNGExport.alignChildren = ['left','top'];
	with( win.group.PNGExport ){
		win.group.PNGExport.Resolution = add( 'group' );
		win.group.PNGExport.Resolution.alignChildren = ['left','center'];
		win.group.PNGExport.Resolution.spacing = 10;
		with( win.group.PNGExport.Resolution ){
			add( 'statictext', undefined, 'Resolution' );
			win.group.PNGExport.Resolution.Wrap = add( 'group' );
			win.group.PNGExport.Resolution.Wrap.orientation = 'stack';
			win.group.PNGExport.Resolution.Wrap.alignChildren = ['left','top'];
			with( win.group.PNGExport.Resolution.Wrap ){
				win.group.PNGExport.Resolution.Value = add( 'edittext' );
				win.group.PNGExport.Resolution.Value.preferredSize.width = 110;
				win.group.PNGExport.Resolution.List = add( 'dropdownlist', undefined, undefined, {items: [72,150,300]} );
				win.group.PNGExport.Resolution.List.preferredSize.width = 130;
				}
			}
		win.group.PNGExport.Color = add( 'dropdownlist', undefined, undefined, {items: ['RGB','GRAY']} );
		win.group.PNGExport.Color.title = 'Color';
		win.group.PNGExport.Color.preferredSize.width = 200;
		win.group.PNGExport.Quality = add( 'dropdownlist', undefined, undefined, {items: ['MAXIMUM','HIGH','MEDIUM','LOW']} );
		win.group.PNGExport.Quality.title = 'Quality';
		win.group.PNGExport.Quality.preferredSize.width = 200;
		}
	
	// jpeg
	win.group.JPEGExport.Resolution.Value.onChange = function(){
		var _resol;
		try{ _resol = +this.text }catch(err){}
		if( !_resol || _resol > 2400 ){
			this.text = JPEG_resolution;
			return alert( 'Incorrect resolution value. Select range 1-2400' );
			}
		JPEG_resolution = _resol;
		}
	win.group.JPEGExport.Resolution.List.onChange = function(){
		JPEG_resolution = win.group.JPEGExport.Resolution.Value.text = this.selection.text;
		this.selection = null;
		}
	win.group.JPEGExport.Color.onChange = function(){
		JPEG_color = this.selection.text;
		}
	win.group.JPEGExport.Quality.onChange = function(){
		JPEG_quality = this.selection.text;
		}
	
	// png
	win.group.PNGExport.Resolution.Value.onChange = function(){
		var _resol;
		try{ _resol = +this.text }catch(err){}
		if( !_resol || _resol > 2400 ){
			this.text = PNG_resolution;
			return alert( 'Incorrect resolution value. Select range 1-2400' );
			}
		PNG_resolution = _resol;
		}
	win.group.PNGExport.Resolution.List.onChange = function(){
		PNG_resolution = win.group.PNGExport.Resolution.Value.text = this.selection.text;
		this.selection = null;
		}
	win.group.PNGExport.Color.onChange = function(){
		PNG_color = this.selection.text;
		}
	win.group.PNGExport.Quality.onChange = function(){
		PNG_quality = this.selection.text;
		}
	
	
	// INI
	
	var res = printerPresetName ? win.group.printerPresets.list.find( printerPresetName ) : null;
	win.group.printerPresets.list.selection = res ? res.index : res;
	if( res == null )
		printerPresetName = '';
	
	var res = pdfPrinterPresetName ? win.group.PDFExportPresets.list.find( pdfPrinterPresetName ) : null;
	win.group.PDFExportPresets.list.selection = res ? res.index : res;
	if( res == null )
		pdfPrinterPresetName = '';
	
	// JPEG
	win.group.JPEGExport.Resolution.Value.text = JPEG_resolution;
	win.group.JPEGExport.Color.selection = win.group.JPEGExport.Color.find( JPEG_color );
	win.group.JPEGExport.Quality.selection = win.group.JPEGExport.Quality.find( JPEG_quality );
	
	// PNG
	win.group.PNGExport.Resolution.Value.text = PNG_resolution;
	win.group.PNGExport.Color.selection = win.group.PNGExport.Color.find( PNG_color );
	win.group.PNGExport.Quality.selection = win.group.PNGExport.Quality.find( PNG_quality );
	
	win.group.selection = activeExportIndex;
	
	// Имя файла / Добавить страницы / ru2en
	
	win.smart_file_name = win.add('group');
	win.smart_file_name.orientation = 'row';
	win.smart_file_name.alignment = ['fill','top'];
	win.smart_file_name.alignChildren = ['right','center'];
	
	// -
	win.smart_file_name.tire = win.smart_file_name.add('button', undefined , '-');
	win.smart_file_name.tire.onClick = function(){
		CUSTOM_FILE_NAME = win.file_name.edit.text += ' - ';
		}
	// add pages
	win.smart_file_name.add_pages = win.smart_file_name.add('button', undefined , 'pages');
	win.smart_file_name.add_pages.onClick = function(){
		CUSTOM_FILE_NAME = win.file_name.edit.text += '_p' + pageRange.replace(/:/g,'_');
		}
	// image name
	win.smart_file_name.add_selected_image_name = win.smart_file_name.add('button', undefined , 'image name');
	win.smart_file_name.add_selected_image_name.helpTip = 'Добавить имя выделеного изображения';
	win.smart_file_name.add_selected_image_name.onClick = function(){
		if( app.selection && app.selection.length ){
			var sel = app.selection[0];
			if( sel.hasOwnProperty('graphics') && sel.graphics.length )
				sel = sel.graphics[0];
			if( sel.hasOwnProperty('itemLink') && sel.itemLink )
				CUSTOM_FILE_NAME = win.file_name.edit.text += (win.file_name.edit.text ? ' - ' : '') + getFileNameOnly( new File(sel.itemLink.name) );
			}
		}
	// folder name
	win.smart_file_name.add_image_folder_name = win.smart_file_name.add('button', undefined , 'folder name');
	win.smart_file_name.add_image_folder_name.helpTip = 'Добавить имя папки из каталога indd-файла';
	win.smart_file_name.add_image_folder_name.onClick = function(){
		if( !DOC_FILE )
			return;
		
		var folders = [];
		DOC_FILE.parent.getFiles( function(thisFile) { if (thisFile instanceof Folder && thisFile.displayName != 'Document Fonts') folders.push(thisFile.displayName) } );
		//alert( folders.join(' ' )); return;
		
		var winList = new Window( 'dialog', 'Добавить имя папки из каталога indd-файла' );
		winList.margins = 5;
		winList.spacing = 5;
		winList.GR = winList.add( 'group' ); // fix for listbox
		winList.list = winList.GR.add( 'listbox', undefined , undefined, {items: folders});
		winList.list.preferredSize.width = 400;
		winList.list.preferredSize.height = 400;
		winList.list.onChange = winList.list.onDoubleClick = function(){
			if( CUSTOM_FILE_NAME && !/-\s*$/.test(CUSTOM_FILE_NAME) )
				CUSTOM_FILE_NAME += ' - '
			CUSTOM_FILE_NAME = win.file_name.edit.text = CUSTOM_FILE_NAME + this.selection.text;
			winList.close();
			}
		winList.center();
		winList.show();
		}
	// ru->en
	win.smart_file_name.ru2en = win.smart_file_name.add('button', undefined , 'ru->en');
	win.smart_file_name.ru2en.helpTip = 'Транслитерация';
	win.smart_file_name.ru2en.onClick = function(){
		CUSTOM_FILE_NAME = win.file_name.edit.text = ru2en( win.file_name.edit.text );
		}
	// for web
	win.smart_file_name.normalize = win.smart_file_name.add('button', undefined , 'for web');
	win.smart_file_name.normalize.helpTip = 'Адаптировать имя файла для web';
	win.smart_file_name.normalize.onClick = function(){
		CUSTOM_FILE_NAME = win.file_name.edit.text = ru2en( win.file_name.edit.text ).replace( /[\s\\\/:*?"<>|]+/g, '_' );
		}
	
	win.file_name = win.add('group');
	win.file_name.orientation = 'row';
	win.file_name.alignment = ['fill','top'];
	win.file_name.alignChildren = ['right','center'];
	with(win.file_name){
		add('statictext', undefined , 'Имя файла: ');
		win.file_name.edit = add('edittext', undefined , undefined);
		win.file_name.edit.preferredSize.width = 400;
		}
	
	addFont( win.file_name.edit, {style:'Bold'} );
	addColor( win.file_name.edit, 1, [255,0,0] );
	win.file_name.edit.onChanging = function(){
		CUSTOM_FILE_NAME = this.text;
		}
	
	if( fileNameMask ){
		CUSTOM_FILE_NAME = fileNameMask;
		// indd_file_name
		if( CUSTOM_FILE_NAME.indexOf('[indd_file_name]') > -1)
			CUSTOM_FILE_NAME = CUSTOM_FILE_NAME.replace( '[indd_file_name]', DOC_FILE ? getFileNameOnly(DOC_FILE) : '' );
		
		var current_page;
		if( app.selection && app.selection.length ){
			var page = getPageOrSpreadOfObject( app.selection[0] );
			if( page ){
				if( page instanceof Spread )
					page = page.pages[0];
				if( page instanceof Page ){
					current_page = page;
					}
				}
			}
		else
			try{
				current_page = app.documents[0].layoutWindows[0].activePage;
				}catch(err){}
		// current_page
		if( CUSTOM_FILE_NAME.indexOf('[current_page]') > -1 ){
			CUSTOM_FILE_NAME = CUSTOM_FILE_NAME.replace( '[current_page]', (current_page ? getPageFullName(current_page) : '') );
			}
		}
	
	if( CUSTOM_FILE_NAME )
		win.file_name.edit.text = CUSTOM_FILE_NAME;
	//else
	//	win.smart_file_name.enabled = win.file_name.enabled = false;
	
	//  Options / Cancel / Print
	
	win.buts = win.add('group');
	win.buts.orientation = 'row';
	win.buts.alignment = ['fill','top'];
	win.buts.alignChildren = ['right','center'];
	with(win.buts){
		win.buts.opts = add("iconbutton", undefined, undefined, {style: "toolbutton"} );
		win.buts.opts.alignment = ['left','center'];
		win.buts.opts.image = ScriptUI.newImage( settings_button );
		win.buts.opts.helpTip = 'Options';
//		win.buts.opts.preferredSize
		//win.buts.autor = add('statictext', undefined, 'Script by Alexey Dmitrienko | alexey-dmitrienko@ya.ru');
		win.buts.cancel = add('button', undefined, 'Cancel');
		win.buts.print = add('button', undefined, 'Print');
		win.buts.print.active = true;
		
		win.buts.printToFolder = add( 'dropdownlist', undefined, ["В папку:", "-"] );
		win.buts.printToFolder.helpTip = 'Печатать в папку';
		win.buts.printToFolder.preferredSize.width = 22;
		for( var i = 0; i < toFolderPatches.length; i++ ){
			if( new Folder(toFolderPatches[i]).exists ){
				win.buts.printToFolder.add('item', toFolderPatches[i]);
				}
			}
		
		win.buts.printToFile = add( 'dropdownlist', undefined, ["В файл:", "-"] );
		win.buts.printToFile.helpTip = 'Печатать в файл';
		win.buts.printToFile.preferredSize.width = 22;
		for( var i = 0; i < toFilePatches.length; i++ ){
			if( new File(toFilePatches[i]).parent.exists ){
				win.buts.printToFile.add('item', toFilePatches[i]);
				}
			}
		}
	//addFont( win.buts.autor, {size:8} );
	
	win.buts.printToFolder.onChange = function(){
		try{
		if( this.selection.index == 0 ){
			return;
			}
		TO_FOLDER = new Folder(this.selection.text);
		if( !TO_FOLDER.exists ){
			alert( 'Folder not found: ' + this.selection.text );
			TO_FOLDER = undefined;
			this.selection = 0;
			return;
			}
		this.selection = 0;
		doPrint();
		}catch(err){alert(err + ', ' + err.line ); }
		}
	win.buts.printToFile.onChange = function(){
		try{
		if( this.selection.index == 0 ){
			return;
			}
		TO_FILE = new File(this.selection.text);
		if( !TO_FILE.parent.exists ){
			alert( 'Folder not found: ' + TO_FILE.parent.fsName );
			TO_FILE = undefined;
			this.selection = 0;
			return;
			}
		this.selection = 0;
		doPrint();
		}catch(err){alert(err + ', ' + err.line ); }
		}
	win.buts.opts.onClick = function(){
		var win_opts = new Window( 'dialog', 'Options' );
		win_opts.margins = 5;
		win_opts.spacing = 5;
		win_opts.alignChildren = 'left';
		win_opts.showUserPresetsOnly = win_opts.add('checkbox', undefined, 'Показывать только пользовательские пресеты');
		win_opts.printToLastSelectedFolder = win_opts.add('checkbox', undefined , 'Выбирать в системном диалоге выбора каталога последнюю папку вывода'); // 'Print to last selected folder'
		win_opts.openOutputFolderAfterPrint = win_opts.add('checkbox', undefined , 'Открывать папку вывода после печати'); // 'Open output folder after print'
		
		with(win_opts){
			win_opts.fileName = add( "panel", undefined, 'Имя файла по умолчанию' );
			win_opts.fileName.alignment = ['fill', 'top'];
			win_opts.fileName.orientation = 'row';
			with(win_opts.fileName){
				win_opts.fileName.field = add( "edittext", undefined, fileNameMask );
				win_opts.fileName.field.preferredSize.width = 400;
				win_opts.fileName.flags = add( "dropdownlist", undefined, undefined, {items: ['flags','-','[indd_file_name]','[current_page]'], } );
				win_opts.fileName.flags.preferredSize.width = 50;
				}
			}
		win_opts.fileName.field.onChange = function(){
			fileNameMask = this.text;
			}
		win_opts.fileName.flags.onChange = function(){
			if( this.selection.index == 0 )
				return;
			win_opts.fileName.field.text += this.selection.text;
			this.selection = 0;
			win_opts.fileName.field.onChange();
			}
		win_opts.fileName.flags.selection = 0;
		
		win_opts.add('statictext'); // отступ
		win_opts.autor = win_opts.add('statictext', undefined, 'Script by Alexey Dmitrienko | alexey-dmitrienko@ya.ru');
		win_opts.autor.alignment = 'center';
		addFont( win_opts.autor, {size:8} );
		
		win_opts.OK = win_opts.add('button', undefined, 'OK');
		win_opts.OK.alignment = 'center';
		
		win_opts.showUserPresetsOnly.onClick = function(){
			showUserPresetsOnly = this.value;
			}
		win_opts.printToLastSelectedFolder.onClick = function(){
			printToLastSelectedFolder = this.value;
			}
	win_opts.openOutputFolderAfterPrint.onClick = function(){
			openOutputFolderAfterPrint = this.value;
			}
	
		// INI
		win_opts.showUserPresetsOnly.value = showUserPresetsOnly;
		win_opts.printToLastSelectedFolder.value = printToLastSelectedFolder;
		win_opts.openOutputFolderAfterPrint.value = openOutputFolderAfterPrint;
		
		win_opts.center();
		win_opts.show();
		}
	win.buts.cancel.onClick = function(){
		this.window.close();
		}
	//win.group.printerPresets.list.onDoubleClick = win.group.PDFExportPresets.list.onDoubleClick = 
	win.buts.print.onClick = doPrint;
	function doPrint(){
		if( !pageRange ){
			alert('Не указан диапазон страниц');
			TO_FOLDER = undefined;
			return;
			}
		
		if( activeExportIndex == 2 ){
			// JPEG
			var _resol;
			try{ _resol = +win.group.JPEGExport.Resolution.Value.text }catch(err){}
			if( !_resol || _resol > 2400 ){
				TO_FOLDER = undefined;
				return alert( 'Incorrect resolution value. Select range 1-2400' );
				}
				
			JPEG_resolution = _resol;
			}
		else if( activeExportIndex == 3 ){
			// PNG
			var _resol;
			try{ _resol = +win.group.PNGExport.Resolution.Value.text }catch(err){}
			if( !_resol || _resol > 2400 ){
				TO_FOLDER = undefined;
				return alert( 'Incorrect resolution value. Select range 1-2400' );
				}
				
			PNG_resolution = _resol;
			}
		
		returnPageRange = pageRange;
		
		win.close();
		}
	
	function checkResolution(){ // return Bool
		
		return true;
		}
	
	if( !pageRange )//если это первая загрузка
		win.quick.buts[autoLoad].onClick();//автовыбор
	else
		win.range.edit.text = pageRange;
	
	win.defaultElement = win.buts.print;
	win.center();
	win.show();
	
	return returnPageRange;
	}catch(err){
		alertError( err );
		}
	}
	
function savePrefs(){
	try{
	var str = '';
	str += 'activeExportIndex = ' + activeExportIndex + ';';
	str += 'showPrintDialog = ' + showPrintDialog + ';';
	str += 'showUserPresetsOnly = ' + showUserPresetsOnly + ';';
	str += 'lastRange = "' + lastRange + '";';
	str += 'printerPresetName = "' + printerPresetName + '";';
	str += 'pdfPrinterPresetName = "' + pdfPrinterPresetName + '";';
	
	str += 'JPEG_color = "' + JPEG_color + '";';
	str += 'JPEG_quality = "' + JPEG_quality + '";';
	str += 'JPEG_resolution = ' + JPEG_resolution + ';';
	
	str += 'PNG_color = "' + PNG_color + '";';
	str += 'PNG_quality = "' + PNG_quality + '";';
	str += 'PNG_resolution = ' + PNG_resolution + ';';
	
	str += 'printSpreads = ' + printSpreads + ';';
	str += 'printBlocks = ' + printBlocks + ';';
	str += 'autoLoad = ' + autoLoad + ';';
//	str += 'lastSelectedFolderPath = "' + lastSelectedFolderPath + '";';
	str += 'printToLastSelectedFolder = ' + printToLastSelectedFolder + ';';
	str += 'openOutputFolderAfterPrint = ' + openOutputFolderAfterPrint + ';';
	str += 'fileNameMask = "' + fileNameMask + '";';
	
	toFolderPatches.splice(10); // обрезаем до 10
	str += 'toFolderPatches = ' + (toFolderPatches.length ? '["' + toFolderPatches.join('","') + '"];' : '[];');
	
	toFilePatches.splice(10); // обрезаем до 10
	str += 'toFilePatches = ' + (toFilePatches.length ? '["' + toFilePatches.join('","') + '"];' : '[];');
	
	if( prefs != str )
		script.insertLabel( str );
	
	app.insertLabel( 'lastSelectedFolderPath', lastSelectedFolderPath );
	}catch(err){alert(err + ', line ' + err.line ); }
	}

function getPageRange( area ){ // return string
	// area = key "current page" | "current spread" | "selected story" | "document" | "selected area"
	try{
		var activePage = app.activeDocument.layoutWindows[0].activePage;
		}catch(err){ 
			var activePage = false;
			}
	switch( area ){
		case 'document'://весь документ
			return getPageFullName( app.activeDocument.pages[0] )+"-"+getPageFullName( app.activeDocument.pages[app.activeDocument.pages.length-1] );
		case 'current page'://текущая страница
			if( app.selection[0] ){
				var page = getPageOrSpreadOfObject(  app.selection[0] );
				if( page && page.constructor == Page )
					return getPageFullName( page );
				}
			if( activePage )
				return getPageFullName( activePage );
			break;
		case 'current spread'://текущий разворот
			if( app.selection[0] ){
				var item = getPageOrSpreadOfObject( app.selection[0] );
				if( page ){
					return item.constructor == Spread ? getPageFullName( item ) :  getPageFullName( item.parent.pages[0] ) +'-'+ getPageFullName( item.parent.pages[1] );;
					}
				}
			if( activePage ){
				if( activePage.parent.pages.length == 2 )//если разворот из двух страниц
					return getPageFullName( activePage.parent.pages[0] ) +'-'+ getPageFullName( activePage.parent.pages[1] );
				else
					return getPageFullName( activePage );
				}
			return false;
		case 'selected story'://выделеная Story
			if( !app.selection[0] ) return false;
			// получаем Story
			var story;
			var obj = app.selection[0];
			try{
				z = 0;
				while( !obj.hasOwnProperty("parentStory") && obj.constructor.name != 'Application' ){
//				while( !/^(Paragraph|Line|InsertionPoint|Character|Text|TextPath|Word|TextColumn)$/.test(obj.constructor.name) && obj.constructor.name != 'Application' ){
					obj = obj.parent;
					}
				story = obj.parentStory;
				}catch(err){ return false; }
			var pageIndex;
			var pageIndexes = [];
			var indexes = [];
			var textContainers = story.textContainers;
			for( var i = 0; i < textContainers.length; i++ ){
				//будет выдавать ошибки если нет текста (т.е. нет insertionPoints) или если фрейм стоит вне страницы (т.е. на монтаж.столе). все это -пропускаем
				//Т.о. в список попадут только фреймы (и патчи) с текстом
				appVersion = parseFloat( app.version );
				if( appVersion < 5 )
					try{ pageIndex = textContainers[i].insertionPoints[0].parentTextFrames[0].parent.documentOffset } catch(err){ continue; }
				else
					try{ pageIndex = textContainers[i].insertionPoints[0].parentTextFrames[0].parentPage.documentOffset } catch(err){ continue; }
				if( indexes[pageIndex] )
					continue;
				pageIndexes.push( pageIndex );
				indexes[pageIndex] = true;
				}
			if( !pageIndexes.length ) return false;
			var pages = app.activeDocument.pages;
			if( pageIndexes.length == 1 ) return getPageFullName( pages[pageIndexes[0]] );
			
			pageIndexes.sort(function(a,b){return (a > b)?1:0});
			var ranges = [ [getPageFullName(pages[pageIndexes[0]])] ];
			try{
			for( var i = 1; i < pageIndexes.length; i++ ){
				if( (pageIndexes[i-1]+1) != pageIndexes[i] ){//если текущая не примыкает к предыдущей - создаем новый range
					ranges.push( [getPageFullName(pages[pageIndexes[i]])] );
					}
				else if( i == (pageIndexes.length - 1) || pageIndexes[i] != (pageIndexes[i+1]-1) )// если текущая примыкает к предыдущей, но не примыкает к следующей, либо это последняя страница - закрываем range
					ranges[ranges.length-1].push( getPageFullName(pages[pageIndexes[i]]) );
				}
			}catch(err){ alert(err + '\r' + err.line) }
			for( var i = 0; i < ranges.length; i++ )
				ranges[i] = ranges[i].join('-');
			return ranges.join(', ');
			break;
		case 'selected area'://выделеная Story
			var SEL = app.selection;
			if( !SEL || !SEL.length || !SEL[0].hasOwnProperty('parentPage') )
				return false;
			var page_indexes = {};
			for( var i = 0; i < SEL.length; i++ ){
				if( !SEL[i].parentPage )
					continue;
				page_indexes[SEL[i].parentPage.documentOffset] = true;
				}
			var indexes = [];
			for( var i in page_indexes )
				indexes.push( i );
			if( !indexes.length )
				return false;
			indexes.sort();
			var pages = app.activeDocument.pages;
			ranges = getPageFullName( pages[indexes[0]] );
			if( indexes.length > 1 )
				ranges = ranges + '-' + getPageFullName( pages[indexes[indexes.length-1]] );
			return ranges;
			break;
		default:
		return false;
		}
	}
function getPageFullName( page ){
	return page.appliedSection.name + page.name;
	}
function getPageOrSpreadOfObject( OBJECT ){ // return Page | Spread | MasterSpread | false
		try{
		// v.2
		if( !OBJECT )
			return false;
		if( OBJECT.constructor.name == 'Application' )
			return false;
		if( OBJECT.hasOwnProperty("parentPage") ){
			if( OBJECT.parentPage )
				return OBJECT.parentPage;
			else return false;
			}
		switch(  OBJECT.parent.constructor.name ){
			case 'Page':
				return OBJECT.parent;
			break;
			case 'Spread':
			case 'MasterSpread':
				return OBJECT.parent;
			break;
			default:
				if( OBJECT.hasOwnProperty("parentTextFrames") ){
					if( !OBJECT.parentTextFrames.length ) // если текст вытеснен
						return arguments.callee( OBJECT.parentStory.textContainers[OBJECT.parentStory.textContainers.length-1] );
					else
						return arguments.callee( OBJECT.parentTextFrames[0] );
					}
				return arguments.callee( OBJECT.parent );
			}
		}catch(err){/*alert(err + ', line: '+err.line); */return false; }
		}

function getCustomDraw( uiObject, args ){// args = { text: 'myButton', font: 'Tahoma', style: 'Bold', size: 12, textRGB: [0,0,0], bgRGB: [0,0,0], uiImage: UIImage } - добавление текста в элемент scriptUI (напр., для добавления текста в iconbutton) и раскраска элемента
	// v.2
	try{
	if( !args )//обнуление, убирает ранее установленное форм-ние (текст и цвет)
		args = uiObject.image ? {uiImage: uiObject.image} : {};
	
	if( args.text )
		addFont( uiObject, args );
	
	uiObject.onDraw = function(){
		try{
		this.graphics.drawOSControl();
		if( args.bgRGB ){
			this.graphics.rectPath( 0, 0, this.size[0], this.size[1] );
			this.graphics.fillPath( this.graphics.newBrush( this.graphics.BrushType.SOLID_COLOR, [args.bgRGB[0]/255, args.bgRGB[1]/255, args.bgRGB[2]/255, 0.5] ) );
			}
		if( args.uiImage ){
			var uiObject_size = this.size ? this.size : this.preferredSize;
			if( args.uiImage.size[0] <= uiObject_size[0] && args.uiImage.size[1] <= uiObject_size[1] ){
				var wh = [args.uiImage.size[0],args.uiImage.size[1]];
				}
			else{ // если иконка  не вписывается в габариты
				// коэфициент уменьшения
				var k = Math.min(uiObject_size[0]/uiObject.image.size[0], uiObject_size[1]/uiObject.image.size[1]);
				var wh = [k*uiObject_size[0],k*uiObject_size[1]];
				}
			var xy = [ (uiObject_size[0]-wh[0])/2, (uiObject_size[1]-wh[1])/2 ];
			this.graphics.drawImage(
				args.uiImage,
				xy[0],
				xy[1],
				wh[0],
				wh[1]
				);
			}
		if( args.text ){
			args.textRGB = args.textRGB || [0,0,0];//по умолчанию - Black
			var textSize = this.graphics.measureString( args.text );
			var x = Math.max(0, (this.size[0] - textSize[0])/2);
			var y = Math.max(0, (this.size[1] - textSize[1])/2);
			this.graphics.drawString( args.text, this.graphics.newPen( this.graphics.PenType.SOLID_COLOR, [args.textRGB[0]/255, args.textRGB[1]/255, args.textRGB[2]/255, 1], 1 ), x, y);
			}
		}catch(err){ throw err } //alert( err + ', line ' + err.line ) }
		};
	
	//активируем изменения
	uiObject.enabled = !uiObject.enabled;
	uiObject.enabled = !uiObject.enabled;
	}catch(err){alert(err + ', line ' + err.line)};
	}
function addFont( uiObject, args ){// args = arguments or uiObject, return uiobject.graphics.font or false. Code of arguments: { font: 'Tahoma', style: 'Bold', size: 12 }, (style: Normal, Bold, Italic, Bolditalic)
	if( args ){
		try{
		if( args.font || args.style || args.size ){
			args.font = args.font || uiObject.graphics.font.name;
			args.style = args.style || uiObject.graphics.font.style;
			args.size = args.size || uiObject.graphics.font.size;
			return uiObject.graphics.font = ScriptUI.newFont(args.font, args.style, args.size);
			}
		else if( args.graphics && args.graphics.font ) //если через args передан uiobject
			return uiObject.graphics.font = args.graphics.font;
		}catch(err){}
		}
	try{ return uiObject.graphics.font }catch(err){ return false }
	}
function addColor( uiObject, type, RGB ){//type: 0 = backgroundColor, 1 = foregroundColor (fontColor), RGB - Array or uiobject. Return uiObject.graphics.[type]Color or false
	if( RGB ){
		try{
		if( !type )
			return uiObject.graphics.backgroundColor = ( RGB instanceof Array ) ? uiObject.graphics.newBrush(uiObject.graphics.BrushType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, 1]) : RGB.graphics.backgroundColor;
		else
			return uiObject.graphics.foregroundColor = ( RGB instanceof Array ) ? uiObject.graphics.newPen(uiObject.graphics.PenType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, 1], 2) : RGB.graphics.foregroundColor;
		}catch(err){}
		}
	//если не указан RGB - просто возвращаем color объекта
	try{ 
		if( !type )
			return uiObject.graphics.backgroundColor;
		else
			return uiObject.graphics.foregroundColor;
		}catch(err){ return false }
	}

function getFileNameOnly( file ){
	if( file instanceof Folder )
		return getFileName( file );
	return getFileName( file ).split('.').slice(0,-1).join('.');
	// вариант 2
	return file.fsName.substring( file.parent.fsName.length+1, file.fsName.lastIndexOf('.') )
	}
function getFileName( file ){
	return file.fsName.split(/[\\\/]/).reverse()[0];
	// вариант 2
	return file.fsName.substring( file.parent.fsName.length+1 );
	}

function alertError( err, sourceOfError ){
	if( !err )
		return;
	var errMessage = ( sourceOfError ? sourceOfError + ': ' : '' ) + ( err.constructor == Error ? err + ' (line ' + err.line + ')' : err );
	alert( errMessage );
	}

function getInDesignIcon( iconCataloquePath ){
//	if( iconCataloquePath && (parseFloat(app.version)-2) >= 5 ){
		if( File.fs == 'Macintosh' )
			iconCataloquePath = iconCataloquePath.replace( /\(([^()]+) Resources\)/, '$1.InDesignPlugin/Versions/A/Resources' );
		if( new File(iconCataloquePath).exists )
			return ScriptUI.newImage( iconCataloquePath );
		// если это неполный путь из каталога - наращиваем
		iconCataloquePath = new File( app.filePath ).fsName + '/Plug-Ins/' + iconCataloquePath;
	//	$.writeln( iconCataloquePath );
		if( new File(iconCataloquePath).exists )
			return ScriptUI.newImage( iconCataloquePath );
//		}
	return false;
	}